/* Copyright Robin Schirrmeister and Simon Skilevic
 * Lecture Efficient Route Planning Summer Semester 2011
 * Uni Freiburg
 */
#include <gtest/gtest.h>
#include "./Dijkstra.h"
#include "./RoadNetwork.h"
#include "./TransitNetworkExpanded.h"

TEST(SimpleDijkstra, computeShortestPath)
{
  {
    // using dummy coordinates[0/0] all the time
    RoadNetwork roadNetwork;
    roadNetwork.parseFromString("Nodes: 0[0/0], 1[0/0], 2[0/0]\n"
                               "Edges: (0 -> 1 | 141.421), (1 -> 2 | 141.421)");
    NoHeuristic noHeuristics;
    NoHeuristic* noHeuristic = &noHeuristics;
    SimpleDijkstra simpleDijkstra(&roadNetwork, noHeuristic);
    simpleDijkstra.computeShortestPath(0, 2, true, true);
    ASSERT_EQ(3, simpleDijkstra.shortestPath.size());
    ASSERT_EQ(0, simpleDijkstra.shortestPath.at(0).id);
    ASSERT_EQ(1, simpleDijkstra.shortestPath.at(1).id);
    ASSERT_EQ(2, simpleDijkstra.shortestPath.at(2).id);
    roadNetwork.parseFromString("Nodes: 0[0/0], 1[0/0], 2[0/0]\n"
                                "Edges: (0 -> 1 | 141.421), (0 -> 2 | 921.954),"
                                " (1 -> 2 | 806.226)");
    simpleDijkstra.computeShortestPath(0, 2, true, true);
    ASSERT_EQ(2, simpleDijkstra.shortestPath.size());
    ASSERT_EQ(0, simpleDijkstra.shortestPath.at(0).id);
    ASSERT_EQ(2, simpleDijkstra.shortestPath.at(1).id);
    roadNetwork.parseFromString("Nodes: 0[0/0], 1[0/0], 2[0/0], 3[0/0], 4[0/0], 5[0/0], 6[0/0], 7[0/0]\n"
                                "Edges: (0 -> 1 | 250), (0 -> 3 | 300), "
                                "(1 -> 2 | 200), (2 -> 4 | 200), "
                                "(2 -> 7 | 282.843), (3 -> 1 | 180.278), "
                                "(3 -> 4 | 111.803), (3 -> 5 | 364.005), "
                                "(4 -> 3 | 111.803), (4 -> 6 | 474.342), "
                                "(6 -> 5 | 158.114), (6 -> 7 | 452.769)");
    simpleDijkstra.computeShortestPath(0, 7, true, true);
    ASSERT_EQ(4, simpleDijkstra.shortestPath.size());
    ASSERT_EQ(0, simpleDijkstra.shortestPath.at(0).id);
    ASSERT_EQ(1, simpleDijkstra.shortestPath.at(1).id);
    ASSERT_EQ(2, simpleDijkstra.shortestPath.at(2).id);
    ASSERT_EQ(7, simpleDijkstra.shortestPath.at(3).id);
  }
}
