/* Copyright Robin Schirrmeister and Simon Skilevic
 * Lecture Efficient Route Planning Summer Semester 2011
 * Uni Freiburg
 * Class for Heuristics usable in dijkstra shortest path algorithm
 */

#ifndef ROUTEPLANNINGV2_HEURISTICS_H_
#define ROUTEPLANNINGV2_HEURISTICS_H_
#include <stdio.h>
#include "./NodeExpanded.h"
class DistanceHeuristic
{
 public:
  DistanceHeuristic() {}
  virtual ~DistanceHeuristic() {}
  virtual double approximateDistance(NodeExpanded* node1, NodeExpanded* node2)
  {return 0.0;}
};

class NoHeuristic: public DistanceHeuristic
{
 public:
  NoHeuristic() {}
  inline double approximateDistance (NodeExpanded* node1, NodeExpanded* node2) { return 0.0;}
};

class StraightLineHeuristic : public DistanceHeuristic
{
 public:
  StraightLineHeuristic() {}
  double approximateDistance(NodeExpanded* node1, NodeExpanded* node2)
  { return node1->straightLineDistanceTo(*node2);}
};
#endif  // ROUTEPLANNINGV2_HEURISTICS_H_

