/* Copyright November 8, 2011 Robin Schirrmeister and Simon Skilevic
 Chair of Algorithms and Datastructures Uni Freiburg
 * Uni Freiburg
 * Testclass for Label and LabelSet Class
 */

#include <stdio.h>
#include <sys/stat.h>
#include <gtest/gtest.h>
#include <vector>
#include "./Label.h"

using std::vector;

TEST(LabelSetTest, labelMustBeAdded)
{
  int transferTime = 4 * 60;
  vector<Label> labels;
  LabelSet labelSet(&labels, transferTime);
  int dummyTripId = -1;
  Connection dummyConnection(dummyTripId);
  int transfers = 0;
  int time = 3.4;
  vector<int> criterias;
  int nodeId = 0;
  int dummyExpandedFromLabelId = -1;
  bool expanded = true;
  bool endStation = false;
  bool createLabel = true;
  bool multiCriteria = true;
  // add several labels that sholdnt be dominated, check if everything is ok
  criterias.push_back(time);
  criterias.push_back(transfers);
  // add several labels
  labelSet.AddLabel(dummyConnection, criterias, nodeId,
                    dummyExpandedFromLabelId, UNKNOWN,
                    expanded, endStation, createLabel,
                    multiCriteria);
  ASSERT_EQ(1, labelSet._labels->size());
  ASSERT_EQ(1, labelSet._expandedFrom.size());
  ASSERT_EQ(0, labelSet._expandedFrom[0][0]);  // check label id
  // TODO(Robin): make tests
  // 1. add two labels that should be added with transfers 3 and 6 or sth
  // 2. add a label that shouldnt be added because it is worse in both criterias
  // 3. add labels that shouldnt be added because they are worse in one criteria
  // and equal in the other
  // 4. add label that shouldnt beadded because its the same in both criterias
  // 5. add label that deletes one other label based on both criterias
  // 6. add label that deletes one other label based on one criteria
  // 7. add label that deletes no label again
  // 8. add label that deletes several other labels
  // 9. add label that deletes all other labels
  // 10. make tests with labels that shouldn't be deleted due to line id or end
  // station or something
}
