// Copyright November 30, 2011 Robin Schirrmeister and Simon Skilevic
// Chair of Algorithms and Datastructures Uni Freiburg

#ifndef ROUTEPLANNING_LIVECONNECTION_H_
#define	ROUTEPLANNING_LIVECONNECTION_H_

#include "./EdgeDependent.h"

enum NetworkType
{
  ROADNETWORK, TRANSITNETWORK, UNKNOWN
};
// Class that represents a connection at a given time
class LiveConnection
{
public:
  Connection connection;
  NetworkType destinationType;
  int toNodeId;
  size_t time;
  size_t transfers;
  // TODO: remove trip ended
  // the trip that was taken before this connection ended at the start station
  // of this connection...
  bool tripBeforeEnded;
  LiveConnection(const Connection& connection, NetworkType destinationType,
                 int destinationNodeId,
                 size_t time,  size_t transfers, bool tripBeforeEnded);
};

#endif  // ROUTEPLANNING_LIVECONNECTION_H_

