// create two text entry fields and a date entry field
// on entry in the text entry fields, display possible stations
// provide calculate trip button,
// when clicked calculate trip, display for each line used the first and last stations,
// i.e. display first departure node, then each departure node and arrival node before or after
// a transfer node, and the last node (should be an arrival node)...
// make it possible to expand part, displaying all arrivals and departures inbetween...
// for this make class trip and class tripparts... 


//TODO(Robin): make several polylines nicer displayable?
// make
// Make stepwith of for and back buttons checkable
// make funciton for enabling/disablign slider that enables and disables all
// the buttons and the slider...
// make buttons appear below the slider...
// make toggle button so that you can actually move ahead towards next
// location id change
// exchange icons to - green for added, yellow expanded, black removed, orange(?) for added and removed
// change expanded to an array as well...
// possibly return some general dijkstra results as well...
// give later drawn lines more opacity and manipulate z indices on right click to
// make underlying polylines visible?
//
// REALLY LATER TODO: possibly make information about individual ndoes during the dijkstra
// available via ajax... FOR example send requests for the currently viewed mappart
// and return the 100 nodes with most labels in the dijkstra for that part...
// maybe use qt isntead of javascript +serer?
// see http://labs.qt.nokia.com/2008/07/03/putting-qtwebkit-to-use-with-google-maps/
// and http://developer.qt.nokia.com/forums/viewthread/12342

var port = "5274";
var host = "stromboli.informatik.uni-freiburg.de"
// from http://aymanh.com/9-javascript-tips-you-may-not-know#assertion
function AssertException(message) {this.message = message;}
  AssertException.prototype.toString = function () {
  return 'AssertException: ' + this.message;
}

function assert(exp, message) {
  if (!exp) {
    throw new AssertException(message);
  }
}
var roadType = 0;
var transitType = 1;
var colorsAsHexCode = ["#0000FF", "#663300", "#FFCC00", "#009966", "#669900", "#CC6666", "#6600FF"];
var typeAndLocationIdToMarkerId = {};
var dijkstraLocations = [];
var typeAndLocationIdToDijkstraLocationId = {};
var currentPaths = [];
var dijkstraStepsMap = {}
var labelsMap = {};
var polylinesArray = [];
var markersArray = [];
var markerInfoWindowsArray = [];
var polylineInfoWindowsArray = [];
function Time(hour, minute, second)
{
  assert(hour >= 0 && hour < 24, "hour should be between 0 and 24");
  assert(minute >= 0 && minute < 60, "minute should be between 0 and 60");
  assert(second >= 0 && second < 60, "second should be between 0 and 60");
  this.hour = hour;
  this.minute = minute;
  this.second = second;
}

// TODO(Robin): actually use this isntead of just constructing the object from json?
function Label(type, locationId, nodeId, arrivedWithTripId, arrivalTime,
               weight, timeSoFar, transfers,
               expandedFromLabelId, removedByLabelId)
{
  this.type = type;
  this.locationId = locationId;
  this.nodeId = nodeId;
  this.arrivedWithTripId = arrivedWithTripId;
  this.arrivalTime = arrivalTime;
  this.weight = weight;
  this.timeSoFar = timeSoFar;
  this.transfers = transfers;
  this.expandedFromLabelId = expandedFromLabelId;
  this.removedByLabelId = removedByLabelId;
}

function DijkstraLocation(type, locationId, latitude, longitude)
{
  this.type = type;
  this.locationId = locationId;
  this.latitude = latitude;
  this.longitude = longitude;
  this.labelIds = [];
  this.getType = function()
  {
    if (this.type === 0) return "Road";
    else if (this.type === 1) return "Transit";
    else assert(false, 'type should be 1 or 0');
  }
}

function deleteMarkers()
{
  typeAndLocationIdToMarkerId = {}
  typeAndLocationIdToMarkerId[roadType] = {}
  typeAndLocationIdToMarkerId[transitType] = {}
  for (i in markersArray)
      markersArray[i].setMap(null);
    markersArray.length = 0;
  markerInfoWindowsArray.length = 0;  // assuming deletion of markers closes infowindows...
}

function drawPaths(paths)
{
  currentPaths = paths;
  // clear existing polylines and markers
  for (i in polylinesArray)
    polylinesArray[i].setMap(null);
  polylinesArray.length = 0;  // taken from google maps javascript v3 api online doc
  for (i in polylineInfoWindowsArray)
    polylineInfoWindowsArray[i].close();
  polylineInfoWindowsArray.length = 0;
  deleteMarkers();
// draw each path
  for (i in paths)
    drawPath(paths[i]);
}

function drawPath(path)
{
  // TODO(Robin): check if line goes on same line as another already existing 
  // line by checking whether marker before and current marker already exist
  // if yes, somehow change color for that part of the line? or make it bigger?
  // or something? :)
  var polyline;
  var nodeArray = path.nodes;
  var polylineColor = colorsAsHexCode[polylinesArray.length % 
                                      colorsAsHexCode.length];
  // create polyline, then add path
  polyline = new google.maps.Polyline({
    path: [],
    strokeColor: polylineColor,
    strokeOpacity: 1.0,
    strokeWeight: 2 * currentPaths.length - 2 * polylinesArray.length + 2
  });
  // TODO(Robin): move this into handle results or just center the map
  // when you first get the station names (then write also locations..)
  var centerLatitude = (nodeArray[0].latitude +
                        nodeArray[nodeArray.length - 1].latitude) / 2;
  var centerLongitude = (nodeArray[0].longitude +
                        nodeArray[nodeArray.length - 1].longitude) / 2;
  var center = new google.maps.LatLng(centerLatitude, centerLongitude);
  for (var i = 0; i < nodeArray.length; i++)
  {
    var node = nodeArray[i];
    var nodePosition = new google.maps.LatLng(node.latitude, node.longitude);
    polyline.getPath().push(nodePosition);
    var infoText = getNetTypeName(node.type) + " " + node.locationId +
             " Trip " + node.arrivedWithTripId + " | " +
             timeToString(node.arrivalTime) + " | " +
             timeToString(node.departureTime) +
             "  (" + (polylinesArray.length + 1) + ") ";  // for seeing which path it is
    var marker;
    if (markerExists(node.type, node.locationId))
    {
      marker = getMarker(node.type, node.locationId);
      marker.setTitle(marker.getTitle() + "\n --- " + infoText);
      var infoWindow = getInfoWindow(node.type, node.locationId)
      infoWindow.setContent(infoWindow.getContent() + "<br />" + infoText);
      
    }
    else
    {
      var icon;
      if (node.type == roadType)
        icon = "./images/green_nanny_small.png";
      else if (node.type == transitType)
        icon = "./images/green_train.png";
      marker = new google.maps.Marker({
      icon: icon,
      position: nodePosition,
      title: infoText});
      addMarker(marker, node.type, node.locationId);
      addInfoWindowToMarker(infoText, marker);
    }
  }
  map.setCenter(center);
  polyline.setMap(map);
  polylinesArray.push(polyline);
  var pathInfoText = createPathTable(path, polylinesArray.length);
  addInfoWindowToPolyline(pathInfoText, polyline);
}



function debugOutputPaths(paths)
{
  $('#resultBox').html('');
  $('#resultBox').append('' + paths.length + " Paths. <br /> <br />");
  for (var i = 0; i < paths.length; i++)
  {
     var path = paths[i];
     $('#resultBox').append(timeToString(path.startTime) + "</br>");
     $('#resultBox').append('Duration: ' + path.duration  + "</br>");
     $('#resultBox').append('Transfers: ' + path.transfers + "</br>");
     var nodes = path.nodes;
     var resultTableString = "";
     resultTableString += '<table id="resultTable_' + i + '">';
     for (var j = 0; j < nodes.length; j++)
     {
       resultTableString += "<tr>";
       var curNode = path.nodes[j];
       resultTableString += "<td> " + getNetTypeName(curNode.type) + "</td>" +
                              "<td> " + curNode.locationId + "</td>" +
                             "<td> (" + curNode.latitude + " / " +
                             curNode.longitude + ") </td>" +
                             "<td> ARR: " + timeToString(curNode.arrivalTime) +
                             "</td>" +
                             "<td> DEP: " + timeToString(curNode.departureTime) +
                             "</td>" +
                             "<td> Trip: " +
                             curNode.arrivedWithTripId + "</td>";

       resultTableString += "</tr>";
     }
     resultTableString += "</table>";
     $('#resultBox').append(resultTableString);
  }
}

function createPathTable(path, pathNr)
{
  var pathTableString =  '<div class ="pathDiv">';
  pathTableString += "<b>Path "+ pathNr +":</b></br>";
  pathTableString += timeToString(path.startTime) + "</br>";
  pathTableString +='Duration: ' + path.duration  + "</br>";
  pathTableString += 'Transfers: ' + path.transfers + "</br>";
  var nodes = path.nodes;

  pathTableString += '<table class="pathTable">';
  for (var j = 0; j < nodes.length; j++)
  {
    pathTableString += "<tr>";
    var curNode = path.nodes[j];
    pathTableString += "<td> " + getNetTypeName(curNode.type) + "</td>" +
                       "<td> " + curNode.locationId + "</td>" +
                       "<td> (" + curNode.latitude + " / " +
                        curNode.longitude + ") </td>" +
                       "<td> ARR: " + timeToString(curNode.arrivalTime) +
                       "</td>" +
                       "<td> DEP: " + timeToString(curNode.departureTime) +
                       "</td>" +
                       "<td> Trip: " +
                           curNode.arrivedWithTripId + "</td>";
    pathTableString +="</tr>";
     }
   pathTableString += "</table>";
   pathTableString += "</div>";
   return pathTableString;
}

// get the location states, i.e. which labels were added, removed, expanded at
// which locations between the first given label id and the last label id
function getLabelSets(startStep, endStep)
{
  // Check that steps are present
  for (var i = startStep; i <= endStep; i++)
  {
    assert(dijkstraStepsMap.hasOwnProperty(i),
          "dijkstra step has to be present to  get its labelsets");
  }
  var typeAndLocationIdToLabelSet= {};
  typeAndLocationIdToLabelSet[roadType] = {};
  typeAndLocationIdToLabelSet[transitType] = {};

  // go through steps, add expanded, added and removed Labels...
  for (var currentStepNr = startStep; currentStepNr <= endStep; currentStepNr++)
  {
    var currentStep = dijkstraStepsMap[currentStepNr];
    var expandedLabel = labelsMap[currentStep.expandedId];

    var labelSet;
    if (!typeAndLocationIdToLabelSet[expandedLabel.type].hasOwnProperty(expandedLabel.locationId))
    {
      typeAndLocationIdToLabelSet[expandedLabel.type][expandedLabel.locationId] = {}
      labelSet = typeAndLocationIdToLabelSet[expandedLabel.type][expandedLabel.locationId];
      labelSet.removedLabels = [];
      labelSet.addedLabels = [];
      labelSet.expandedLabels = [];
    }
    
    labelSet = typeAndLocationIdToLabelSet[expandedLabel.type][expandedLabel.locationId];
    labelSet.expandedLabels.push(expandedLabel);
    for (var i in currentStep.addedIds)
    {
      var addedLabel = labelsMap[currentStep.addedIds[i]];

      if (!typeAndLocationIdToLabelSet[addedLabel.type].hasOwnProperty(addedLabel.locationId))
      {
        typeAndLocationIdToLabelSet[addedLabel.type][addedLabel.locationId] = {}
        labelSet = typeAndLocationIdToLabelSet[addedLabel.type][addedLabel.locationId];
        labelSet.removedLabels = [];
        labelSet.addedLabels = [];
        labelSet.expandedLabels = [];
      }
      labelSet = typeAndLocationIdToLabelSet[addedLabel.type][addedLabel.locationId];
      labelSet.addedLabels.push(addedLabel);
    }
    for (var i in currentStep.removedIds)
    {
      var removedLabel = labelsMap[currentStep.removedIds[i]];

      if (!typeAndLocationIdToLabelSet[removedLabel.type].hasOwnProperty(removedLabel.locationId))
      {
        typeAndLocationIdToLabelSet[removedLabel.type][removedLabel.locationId] = {}
        labelSet = typeAndLocationIdToLabelSet[removedLabel.type][removedLabel.locationId];
        labelSet.removedLabels = [];
        labelSet.addedLabels = [];
        labelSet.expandedLabels = [];
      }
      labelSet = typeAndLocationIdToLabelSet[removedLabel.type][removedLabel.locationId];
      labelSet.removedLabels.push(removedLabel);
    }
  }
  return typeAndLocationIdToLabelSet;
}

function drawDijkstraSteps(startStep, endStep)
{
  drawLabelSets(getLabelSets(startStep, endStep));
}


function drawLabelSets(dijkstraLabelSets)
{
  deleteMarkers();
  for (var type in dijkstraLabelSets)
  {
    for (var locationId in dijkstraLabelSets[type])
    {
      var labelSet = dijkstraLabelSets[type][locationId];
      var dijkstraLocationId = typeAndLocationIdToDijkstraLocationId[type][locationId];
      var dijkstraLocation = dijkstraLocations[dijkstraLocationId];

      var iconOffset = 0.00;
      var position = new google.maps.LatLng(dijkstraLocation.latitude - iconOffset, dijkstraLocation.longitude);
      var marker;
      var icon;
      var infoText = "";
      var tableHeader = "<th>type</th><th>labelId</th><th>time</th><th>Transfers</th><th>weight</th>" +
                        "<th>arrivalTime</th><th>trip</th><th>expandedBy</th><th>removedBy</th>"
      if (labelSet.expandedLabels.length > 0)
      {infoText += "<div class= \"expandedLabelsDiv\">Expanded:";
        infoText += "<table class =\"expandedLabelsTable\">"+ tableHeader;
        for (var i in labelSet.expandedLabels)
          {
            var curLabel = labelSet.expandedLabels[i];
            infoText += labelToHtmlTableRow(curLabel);
          }
        infoText += "</table></div>";
        if (type == roadType)
          icon = "./images/yellow-dot.png";
        else if (type == transitType)
          icon = "./images/yellow_square.png";
        else
          assert(false, "unknown network type " + type);
      }
      else if (labelSet.addedLabels.length === 0 && labelSet.removedLabels.length === 0)
        continue;
      else if (labelSet.addedLabels.length > 0 && labelSet.removedLabels.length > 0)
      {
        if (type == transitType)
          icon = "./images/black_square_big.jpg";
        else if (type == roadType)
          icon = "./images/black_square_big.jpg";
        else
          assert(false, "unknown network type\n");

      }
      else if (labelSet.addedLabels.length > 0)
      {
        if (type == roadType)
          icon = "./images/green-dot.png";
        else if (type == transitType)
          icon = "./images/green_square.png";
        else
          assert(false, "unknown network type " + type);
      }
      else if(labelSet.removedLabels.length > 0)
      {
         if (type == transitType)
          icon = "./images/black_square_big.jpg";
        else if (type == roadType)
          icon = "./images/black_square_big.jpg";
        else
          assert(false, "unknown network type\n");
      }

      if (labelSet.addedLabels.length > 0)
      {
        infoText += "<div class= \"addedLabelsDiv\">Added:";
        infoText += "<table class =\"addedLabelsTable\">"+ tableHeader;
        for (var i in labelSet.addedLabels)
          {
            var curLabel = labelSet.addedLabels[i];
            infoText += labelToHtmlTableRow(curLabel);
          }
        infoText += "</table></div>";
      }
      if (labelSet.removedLabels.length > 0)
      {
        infoText += "<div class= \"removedLabelsDiv\">";
        infoText +="Removed:" +
                    "<table class =\"removedLabelsTable\">"+ tableHeader;
        for (var i in labelSet.removedLabels)
        {
              var curLabel = labelSet.removedLabels[i];
              infoText += labelToHtmlTableRow(curLabel);
        }
        infoText += "</table></div>";
      }
      marker = new google.maps.Marker({
      icon: icon,
      position: position,
      title: type});
      addMarker(marker, type, locationId);
      addInfoWindowToMarker(infoText, marker);
    }
  }
}

//TODO(Robin): make seperator an argument of the function?
function labelToHtmlTableRow(label)
{
  return "<tr><td>" +
          getNetTypeName(label.type) + "</td><td>" +
          label.id + "</td><td>" +
          label.time +  "</td><td>" +
          label.transfers + "</td><td>" +
          label.weight + "</td><td>" +
          timeToString(label.arrivalTime) + " </td><td>" +
          label.tripId + "</td><td>" +
          label.expandedFromLabelId + " </td><td>" +
          label.removedByLabelId + "</tr>" +
          label.locationId + "</tr>";
}

function addInfoWindowToPolyline(infoText, polyline)
{
  var infoWindow = new google.maps.InfoWindow({
    content: infoText
  });
  google.maps.event.addListener(polyline, 'click', function(event){
      infoWindow.setPosition(event.latLng);
      infoWindow.open(map);
    });
   polylineInfoWindowsArray.push(infoWindow);
  assert(polylineInfoWindowsArray.length == polylinesArray.length,
         ' there should be exactly one info window for one polyline' );
}

function addInfoWindowToMarker(infoText, marker)
{
  var infoWindow = new google.maps.InfoWindow({
    content: infoText
  });
  google.maps.event.addListener(marker, 'click', function(){
      infoWindow.open(map, marker);
  });
  markerInfoWindowsArray.push(infoWindow);
  assert(markerInfoWindowsArray.length == markersArray.length,
         ' there should be exactly one info window for one marker' );
}

function addMarker(marker, networkType, locationId)
{
  assert(typeAndLocationIdToMarkerId.hasOwnProperty(networkType),
      "network type should exist in type and location id object");
  marker.setMap(map);
  markersArray.push(marker);
  typeAndLocationIdToMarkerId[networkType][locationId] = markersArray.length - 1;
}

function markerExists(networkType, locationId)
{
  return typeAndLocationIdToMarkerId.hasOwnProperty(networkType) &&
    typeAndLocationIdToMarkerId[networkType].hasOwnProperty(locationId);
}

function getMarker(networkType, locationId)
{
  if (!typeAndLocationIdToMarkerId.hasOwnProperty(networkType))
  {
      typeAndLocationIdToMarkerId[networkType] = {};
      return undefined;
  }
  else if (!typeAndLocationIdToMarkerId[networkType].hasOwnProperty(locationId))
  {
      return undefined;
  }
  else
  {
    assert(markerExists(networkType, locationId), "marker should exist");
    var markerId = typeAndLocationIdToMarkerId[networkType][locationId];
    return markersArray[markerId];
  }
}

function getInfoWindow(networkType, locationId)
{
  // check that marker exists
  assert(typeAndLocationIdToMarkerId.hasOwnProperty(networkType) &&
      typeAndLocationIdToMarkerId[networkType].hasOwnProperty(locationId),
      "marker for info window has to exist");
  var markerId = typeAndLocationIdToMarkerId[networkType][locationId]
  var infoWindow = markerInfoWindowsArray[markerId];
  return infoWindow;
}

function pad(number, properLength)
{
    var str = '' + number;
    while (str.length < properLength) {
        str = '0' + str;
    }
    return str;
}
function timeToString(time)
{
  var timeString = pad(time.hour, 2) + ":" + pad(time.minute, 2) + ":" +
                   pad(time.second, 2);
  return timeString;
}

function getNetTypeName(typeNr)
{
  if (typeNr == 0)
    return "Road";
  else if (typeNr == 1)
    return "Transit";
  else
    assert(false, "network type " + typeNr + " not known");
  return false;
}


function handleNewResult(json, text, xhqr)
{
  // request the statistics for that result...
  requestDijkstraStatistics();
  labelsMap ={};
  dijkstraLocations = [];
  dijkstraStepsMap = {};
  typeAndLocationIdToDijkstraLocationId = {};
  var paths = json.paths;
  //output debug text first, then actually draw the paths
  debugOutputPaths(paths);
  drawPaths(paths);
  $("#showDijkstraButton").attr('checked', false);
  $("#showDijkstraButton").button('refresh');
  $("#showDijkstraDiv").show();
}

function handleStationNames(json, text, xhqr)
{
  var stopNames = json.stopNames;
  var stopNamesAndNumber = [];
  for (var i = 0; i < stopNames.length; i++)
    stopNamesAndNumber.push("( " + i + " )" + stopNames[i]);

  $("#departureEntry").autocomplete(
  {
    source:stopNamesAndNumber
  });
  $("#destinationEntry").autocomplete(
  {
    source:stopNamesAndNumber
  });
}

function addCompressedDijkstraLocations(compressedDijkstraLocations,
                                        propertyIndices)
{
  var usedLocations = compressedDijkstraLocations;
  var typeIndex = propertyIndices["type"];
  var locationId = propertyIndices["locationId"];
  var latitude = propertyIndices["latitude"];
  var longitude = propertyIndices["longitude"];
  for (var i in usedLocations)
  {
    var dijkstraLocation = new DijkstraLocation(usedLocations[i][typeIndex],
                                                usedLocations[i][locationId],
                                                usedLocations[i][latitude],
                                                usedLocations[i][longitude]);
   if (typeAndLocationIdToDijkstraLocationId[dijkstraLocation.type].hasOwnProperty(dijkstraLocation.locationId))
     continue;
   else
   {
      typeAndLocationIdToDijkstraLocationId[dijkstraLocation.type]
                                           [dijkstraLocation.locationId] = dijkstraLocations.length;
      dijkstraLocations.push(dijkstraLocation);
    }
  }
}
function labelExists(label)
{
  return labelsMap.hasOwnProperty(label.id);
}

function addLabel(label)
{
// if label already added, ignore it
  if (labelExists(label))
    return;
  labelsMap[label.id] = label;
  // remember label ids...
  var dijkstraLocationId = typeAndLocationIdToDijkstraLocationId[label.type]
                                                          [label.locationId];
  var dijkstraLocation = dijkstraLocations[dijkstraLocationId];
  dijkstraLocation.labelIds.push(label.id);
}



function addDijkstraSteps(dijkstraSteps)
{
  for (var i in dijkstraSteps)
  {
    var dijkstraStep = dijkstraSteps[i];
    dijkstraStepsMap[dijkstraStep.stepNr] = dijkstraStep;
  }
}
function setLastDisplayedStep (nextLastDisplayedStepNr)
{

  var numOfBufferSteps = 350;
  console.log("Old Step Value" + lastDisplayedStep);
  console.log("New Step Value" + nextLastDisplayedStepNr);
  assert(lastDisplayedStep !== nextLastDisplayedStepNr ||
        nextLastDisplayedStepNr === 0 ||
        nextLastDisplayedStepNr ==  $("#slider").slider("option", "max"),
      "steps displayed should be different if not at first or last step");
  var startStepToDisplay;
  var endStepToDisplay;
  // disply either just one step, (next step)
  // all steps since the last step (if several steps are inbetween
  // last step and this step)
  // or just the next displayed step if you go backwards in time
  // or just the first step if you go towards the start
  if ((lastDisplayedStep + 1) == nextLastDisplayedStepNr)
  {
    startStepToDisplay = nextLastDisplayedStepNr;
    endStepToDisplay = nextLastDisplayedStepNr;
  }
  else if ((lastDisplayedStep + 1) < nextLastDisplayedStepNr)
  {
    startStepToDisplay = lastDisplayedStep;
    endStepToDisplay = nextLastDisplayedStepNr;
  }
  else if ((lastDisplayedStep + 1) >  nextLastDisplayedStepNr)
  {
    startStepToDisplay = nextLastDisplayedStepNr;
    endStepToDisplay = nextLastDisplayedStepNr;
  }
  console.log("startstep: " + startStepToDisplay);
  console.log("endStep: " + endStepToDisplay);
  for (var curStep = startStepToDisplay; curStep <= endStepToDisplay; curStep++)
  {
    if (!dijkstraStepsMap.hasOwnProperty(curStep))
    {
        requestDijkstraSteps(curStep,  curStep + numOfBufferSteps);
        var sliderDiv = $("#slider");
        sliderDiv.slider("disable");
        return;
    }
  }

  $("#slider").slider("enable");
  drawDijkstraSteps(startStepToDisplay, endStepToDisplay);
  lastDisplayedStep = endStepToDisplay;
}
function setSliderMaximumValue(max)
{
  $("#slider").slider("option", "max", max);
}

function handleDijkstraSteps(json)
{
  $("#dijkstraLabelRange").show();
  // remember dijkstra steps label ids
  addDijkstraSteps(json.dijkstraSteps);
  // add labels to label map
  
  // get labelsets from dijsktra steps
  // draw labelsets
  var numberOfExpandedLabelsInDijkstra = json.numberOfExpandedLabelsInDijkstra;
  setSliderMaximumValue(numberOfExpandedLabelsInDijkstra - 1);
  var newDijkstraLocations =  json.dijkstraLocations;
  var usedLocations = JSON.parse(newDijkstraLocations.usedLocations);
  addCompressedDijkstraLocations(usedLocations,
                                 newDijkstraLocations.propertyKeys);
  var propertyIndices = json.propertyKeys;
  var properties = ["id", "type", "locationId", "nodeId", "tripId","arrivalHour",
                    "arrivalMinute", "arrivalSecond", "weight", "time",
                    "transfers", "expandedFromLabelId", "removedByLabelId"];
  var labels = JSON.parse(json.labels);
  // create the labels
  for (var i in labels)
  {
    var label = {};
    for (var j in properties)
    {
      var property = properties[j];
      label[property] = labels[i][propertyIndices[property]];
    }
    // now create proper time object
      assert(label.type === transitType || label.type === roadType,
             "type \"" + label.type + "\" of label not known");
    var labelTime = new Time(label.arrivalHour, label.arrivalMinute,
                               label.arrivalSecond);
    label["arrivalTime"] = labelTime;
    delete label.arrivalHour;
    delete label.arrivalMinute;
    delete label.arrivalSecond;
    addLabel(label);
  }
  deleteMarkers();
  // now set the last displayed step to correct value depending on slider...
  var sliderValue = $("#slider").slider("value");
  setLastDisplayedStep(sliderValue);
}
function handleDijkstraStatistics(json)
{
  var statisticsText = json.statisticsText;
  $("#dijkstraStatisticsDiv").html(statisticsText);
}

function sendNewQuery(startStation, endStation, hour, minute, second)
{
  var url = "http://" + host + ":" + port + "/"
          + 'NEWQUERY:' + startStation + '||' + endStation + '||' + hour + '||'
          + minute + '||' + second;
  $.ajax(url, {dataType: "jsonp"});
}

function requestDijkstraStatistics()
{
  var url = "http://" + host + ":" + port + "/"
          + 'GETDIJKSTRASTATISTICS:';
  $.getScript(url);
}
function requestDijkstraResults()
{
  var url = "http://" + host + ":" + port + "/"
          + 'GETDIJKSTRARESULTS:';
  $.getScript(url);
}

function requestDijkstraSteps(startStep, endStep)
{
  var url = "http://" + host + ":" + port + "/"
          + 'GETDIJKSTRASTEPS:' + startStep + "," + endStep;
  $.getScript(url);
}

function dijkstraButtonClicked()
{ 
  if ($(this).attr('checked') !== undefined)
  {
    // TODO(RObin); make assert dijkstra locatiosn length = 0
    // ...
    if (dijkstraLocations.length == 0)
    {
      typeAndLocationIdToDijkstraLocationId[transitType] = {};
      typeAndLocationIdToDijkstraLocationId[roadType] = {};
      requestDijkstraSteps(0, 200);
    }
    else
    {
      $("#dijkstraLabelRange").hide();

    }
  }
  else
  {
    deleteMarkers();
    drawPaths(currentPaths);
  }
}

var lastDisplayedStep = 0;

function sliderChanged(event, ui)
{
  console.log("New Slider Value" + ui.value);
  setLastDisplayedStep(ui.value);
}

function backwardButtonClicked()
{
  var dijkstraStepSize  = parseInt($("#dijkstraStepSize").val());
  if (dijkstraStepSize == 0)
    dijkstraStepSize = 1;
  var sliderDiv = $("#slider");
  var oldSliderValue = sliderDiv.slider("value");
  if (oldSliderValue - dijkstraStepSize  < 0) return;
  else
    sliderDiv.slider("value", oldSliderValue - dijkstraStepSize);
}

function forwardButtonClicked()
{
  var sliderDiv = $("#slider");
  var dijkstraStepSize  = parseInt($("#dijkstraStepSize").val());
  if (dijkstraStepSize == 0)
    dijkstraStepSize = 1;
  sliderDiv.slider("value", sliderDiv.slider("value") +
                            dijkstraStepSize);
}

$(document).ready(function(){
  var url = "http://" + host + ":" + port + "/" + "GETSTATIONNAMES:";
  $.ajax(url, {dataType: "jsonp"});
  var latlng = new google.maps.LatLng(49.23, 7.0);
  var myOptions = {
    zoom: 12,
    center: latlng,
    mapTypeId: google.maps.MapTypeId.ROADMAP
  };
  map = new google.maps.Map(document.getElementById("map_canvas"),
    myOptions);
  $("#showDijkstraButton").button();
  $("#showDijkstraButton").click(dijkstraButtonClicked);
  $("#slider").slider();
  $("#backwardButton").button();
  $("#forwardButton").button();
  $("#backwardButton").click(backwardButtonClicked);
  $("#forwardButton").click(forwardButtonClicked);
  $("#dijkstraLabelRange").hide();
  $("#slider").bind('slidechange', sliderChanged);
});



/*
function drawDijkstraResults()
{
  deleteMarkers();
  for (i in dijkstraLocations)
  {
    var dijkstraLocation = dijkstraLocations[i];
    var position = new google.maps.LatLng(dijkstraLocation.latitude,
                                          dijkstraLocation.longitude);
    var infoText = dijkstraLocation.type;
    var marker = new google.maps.Marker({
      icon: "./images/green-dot.png",
      position: position,
      title: infoText});

      addMarker(marker, dijkstraLocation.type, dijkstraLocation.locationId);
      addInfoWindowToMarker(infoText, marker);
  }
}
*/

/*
function handleDijkstraResults(json)
{
  alert('handling results');

  var usedLocations = JSON.parse(json.usedLocations);
  var propertyIndices = json.propertyKeys;
  alert ('' + usedLocations.length + 'results');
  typeAndLocationIdToDijkstraLocationId[transitType] = {};
  typeAndLocationIdToDijkstraLocationId[roadType] = {};
  addCompressedDijkstraLocations(usedLocations, propertyIndices);
  alert('before drawing');
  //drawDijkstraResults();
  var maxNumberOfLabels = 10000000;
  requestLabels(0, maxNumberOfLabels);
}
*/
